// Below is the code as used in ./GPIO to access the GPIO.  This program simply sends four integer parameters to ./linux64lic and gets a 8 bit integer returned.  The parameters are the Configuration and Setup of the GPIO ports and selects what port to return.  The 8 bit integer returned is the read of one of the GPIO ports.  Another way to run your own quick test is to run ./linux64lic 255 0 0 255 from the Terminal.

# include <stdio.h>
# include <unistd.h>
# include <sys/wait.h>
# include <signal.h>

void DoGPIO(char *args[]){
	int status = 0, status2 = 0, GPIOReturned = 0;
	pid_t childpid;
	
	childpid = fork();
	if (childpid >= 0){ // fork worked
		if (childpid == 0){
			printf("child %d\n", getpid());
			printf("execlp Exit Code = %d\n",execlp("./linux64lic", "6", args[0], args[1], args[2], args[3], args[4], NULL)); // This calls ./linux64lic
			printf("child Done\n");
		}
		else{
			printf("parent %d\n", getpid());
			status2 = wait(&status);	
			GPIOReturned = WEXITSTATUS(status); // This is the GPIO port read value.
			printf("GPIO Returned = %X\n", GPIOReturned); 
			printf("Parent Done\n");
		}
	}
}

// All GPIO values are sent in decimal.
void main(int argc, char** argv){
	char *args[] = {"0", "255", "255", "0", "1"}; // This setup GPIO port 0 as Outputs 0, port 1 as inputs 0xFF(255), puts 0xFF(255) on port 0, puts 0 on port 1, and selects port 1 to read.
	char *args2[] = {"0", "255", "170", "0", "1"}; // This setup GPIO port 0 as Outputs 0, port 1 as inputs 0xFF(255), puts 0xAA(170) on port 0, puts 0 on port 1, and selects port 1 to read.
	char *args3[] = {"0", "255", "85", "0", "1"}; // This setup GPIO port 0 as Outputs 0, port 1 as inputs 0xFF(255), puts 0x55(85) on port 0, puts 0 on port 1, and selects port 1 to read.
	char *args4[] = {"255", "0", "0", "255",  "0"}; // This setup GPIO port 0 as inputs 0xFF(255), port 1 as outputs 0, puts 0 on port 0, puts 0xFF(255) on port 1, and selects port 0 to read.
	char *args5[] = {"255", "0", "0", "170", "0"}; // This setup GPIO port 0 as inputs 0xFF(255), port 1 as outputs 0, puts 0 on port 0, puts 0xAA(170) on port 1, and selects port 0 to read.
	char *args6[] = {"255", "0", "0", "85", "0"}; // This setup GPIO port 0 as inputs 0xFF(255), port 1 as outputs 0, puts 0 on port 0, puts 0x55(85) on port 1, and selects port 0 to read.

	DoGPIO(args);
	DoGPIO(args2);
	DoGPIO(args3);
	DoGPIO(args4);
	DoGPIO(args5);
	DoGPIO(args6);
}
